/*--------------*/
/* ApBox.java   */
/*--------------*/
import java.applet.Applet;
import java.awt.*;                          //BorderLayout,GraphicsConfiguration,event
import javax.media.j3d.*;                   //Java3d
import com.sun.j3d.utils.applet.MainFrame;  //MainFrame
import com.sun.j3d.utils.universe.*;        //SimpleUniverse
import com.sun.j3d.utils.geometry.*;        //Primitive
import javax.vecmath.*;                     //Point3f,Color3f

public class ApBox extends Applet{

    private SimpleUniverse simpleU;
    private BoundingSphere bounds = new BoundingSphere(new Point3d(), 10.0);

    public void init(){

        //ץåȤCanvas3Dɲ
        setLayout(new BorderLayout());
        Canvas3D canvas = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
        add(canvas, BorderLayout.CENTER);

        //󥰥դ
        simpleU = new SimpleUniverse(canvas);
        simpleU.getViewingPlatform().setNominalViewingTransform();

        //󥰥դκ
        simpleU.addBranchGraph(createSceneGraph());
    }

    private BranchGroup createSceneGraph(){

        BranchGroup branchG0 = new BranchGroup();

        //طʿ̵꤬Ϲ
        Background background = new Background(new Color3f(1.0f, 1.0f, 1.0f));
        background.setApplicationBounds(bounds);
        branchG0.addChild(background);

        branchG0.addChild(createDirectionalLight());     //饤Ȥɲ

        Transform3D rotationX = new Transform3D();
        Transform3D rotationY = new Transform3D();
        rotationX.rotX(Math.PI/6);                      //30ٲž
        rotationY.rotY(-Math.PI/9);                     //20ٲž
        rotationX.mul(rotationY);                       //
        TransformGroup transG0 = new TransformGroup(rotationX);
        branchG0.addChild(transG0);

        createAxis(transG0);                           //ɸκ

        //Appearance
        Appearance ap = new Appearance();
        Material ma = new Material();
        ma.setDiffuseColor(new Color3f( 1.0f, 0.7f, 1.0f));
        ap.setMaterial(ma);

        //ʪΤ
        Box box = new Box(0.5f, 0.5f, 0.5f, ap);
        transG0.addChild(box);

        branchG0.compile();

        return branchG0;
    }

    //ʬ䤹褦˺ɸ
    private void createAxis(TransformGroup tg){

        Point3f[] vertex = new Point3f[6];
        vertex[0] = new Point3f(-1.0f, 0.0f, 0.0f);
        vertex[1] = new Point3f( 1.0f, 0.0f, 0.0f);
        vertex[2] = new Point3f( 0.0f,-1.0f, 0.0f);
        vertex[3] = new Point3f( 0.0f, 1.0f, 0.0f);
        vertex[4] = new Point3f( 0.0f, 0.0f,-1.0f);
        vertex[5] = new Point3f( 0.0f, 0.0f, 1.0f);

        Appearance ap = new Appearance();
        ColoringAttributes ca = new ColoringAttributes();
        ca.setColor(new Color3f(0.0f, 0.0f, 0.0f));
        ap.setColoringAttributes(ca);

        //2Ȥʤ
        LineArray LineA = new LineArray(vertex.length,
            GeometryArray.COORDINATES);
        LineA.setCoordinates(0, vertex);
        Shape3D line3D = new Shape3D(LineA, ap);
        tg.addChild(line3D);

        //ɸ̾ɽ
        Vector3f[] vector = new Vector3f[3];
        vector[0] = new Vector3f(  0.8f, 0.0f, 0.0f);
        vector[1] = new Vector3f( 0.05f, 0.8f, 0.0f);
        vector[2] = new Vector3f(-0.05f, 0.0f, 0.8f);

        String[] axis = {"x","y","z"};
        Transform3D trans = new Transform3D();
        for(int i=0;i<3;i++){
            trans.setTranslation(vector[i]);
            TransformGroup transG = new TransformGroup(trans);
            Text2D text2d = new Text2D(axis[i],                         //ʸ
                                        new Color3f(0.0f, 0.0f, 0.0f),  //եȿ
                                        "Serif", 30, Font.BOLD);        //եȾ
            transG.addChild(text2d);
            tg.addChild(transG);
        }
    }

    //ʿԸ
    private Light createDirectionalLight(){

        DirectionalLight lightD = new DirectionalLight();   //ǥեȤʿԸ
        lightD.setInfluencingBounds(bounds);                //ƶϰ

        return lightD;
    }

    public void destroy(){

        simpleU.cleanup();
    }

    public static void main(String[] args){    //Application

        MainFrame frame = new MainFrame(new ApBox(), 256, 256);
    }
}

