/*--------------*/
/* Ex42.java    */
/*--------------*/
import java.applet.Applet;
import java.awt.*;                          //BorderLayout,GraphicsConfiguration,event
import javax.media.j3d.*;                   //Java3d
import com.sun.j3d.utils.applet.MainFrame;  //MainFrame
import com.sun.j3d.utils.universe.*;        //SimpleUniverse
import com.sun.j3d.utils.geometry.*;        //Primitive
import javax.vecmath.*;                     //Point3f,Color3f

public class Ex42 extends Applet{

    private SimpleUniverse simpleU;
    private BoundingSphere bounds = new BoundingSphere(new Point3d(), 10.0);

    public void init(){

        //ץåȤCanvas3Dɲ
        setLayout(new BorderLayout());
        Canvas3D canvas = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
        add(canvas, BorderLayout.CENTER);

        //󥰥դ
        simpleU = new SimpleUniverse(canvas);
        simpleU.getViewingPlatform().setNominalViewingTransform();

        //󥰥դκ
        simpleU.addBranchGraph(createSceneGraph());
    }

    private BranchGroup createSceneGraph(){

        BranchGroup branchG0 = new BranchGroup();

        //طʿ̵꤬Ϲ
        Background background = new Background(new Color3f(0.8f, 0.8f, 0.8f));
        background.setApplicationBounds(bounds);
        branchG0.addChild(background);

        //ɸϤ̾Ʒ
        Transform3D tran = new Transform3D();
        Transform3D rotx = new Transform3D();
        tran.setTranslation(new Vector3f(-0.7f, 0.0f, 0.0f));
        rotx.rotX(Math.PI/4);                                     //90ٲž
        tran.mul(rotx);                                            //
        TransformGroup transG0 = new TransformGroup(tran);
        branchG0.addChild(transG0);

        createAxis(transG0);                                       //ɸκ

        //Text2D
        Text2D text2d = new Text2D("Ϻ",                     //ʸ
                                    new Color3f(1.0f, 0.0f, 0.0f), //եȿ
                                    "Dialog", 90, Font.PLAIN);     //եȾ
//                                    "Dialog", 90, Font.ITALIC);    //եȾ
//                                    "Dialog", 90, Font.BOLD);      //եȾ
        transG0.addChild(text2d);

        branchG0.compile();

        return branchG0;
    }

    //ʬ䤹褦˺ɸ
    private void createAxis(TransformGroup tg){

        Point3f[] points = new Point3f[6];
        points[0] = new Point3f(-1.0f, 0.0f, 0.0f);
        points[1] = new Point3f( 1.0f, 0.0f, 0.0f);
        points[2] = new Point3f( 0.0f,-1.0f, 0.0f);
        points[3] = new Point3f( 0.0f, 1.0f, 0.0f);
        points[4] = new Point3f( 0.0f, 0.0f,-1.0f);
        points[5] = new Point3f( 0.0f, 0.0f, 1.0f);

        Appearance ap = new Appearance();
        ColoringAttributes ca = new ColoringAttributes();
        ca.setColor(new Color3f(0.0f, 0.0f, 0.0f));
        ap.setColoringAttributes(ca);

        //2Ȥʤ
        LineArray lineA = new LineArray(points.length,
            GeometryArray.COORDINATES);
        lineA.setCoordinates(0, points);
        Shape3D shape = new Shape3D(lineA, ap);
        tg.addChild(shape);

        //ɸ̾ɽ
        Vector3f[] vector = new Vector3f[3];
        vector[0] = new Vector3f(  0.8f, 0.0f, 0.0f);
        vector[1] = new Vector3f( 0.05f, 0.8f, 0.0f);
        vector[2] = new Vector3f(-0.05f, 0.0f, 0.8f);

        String[] axis = {"x","y","z"};
        Transform3D trans = new Transform3D();
        for(int i=0;i<3;i++){
            trans.set(vector[i]);
            TransformGroup transG = new TransformGroup(trans);
            Text2D text2d = new Text2D(axis[i],                         //ʸ
                                        new Color3f(0.0f, 0.0f, 1.0f),  //եȿ
                                        "Serif", 30, Font.BOLD);        //եȾ
            transG.addChild(text2d);
            tg.addChild(transG);
        }
    }

    public void destroy(){

        simpleU.cleanup();
    }

    public static void main(String[] args){    //Application

        MainFrame frame = new MainFrame(new Ex42(), 512, 512);
    }
}
