/*------------*/
/* Ja66.java  */
/*------------*/
import java.applet.Applet;
import java.awt.*;                          //BorderLayout,GraphicsConfiguration,event
import javax.media.j3d.*;                   //Java3d
import com.sun.j3d.utils.applet.MainFrame;  //MainFrame
import com.sun.j3d.utils.universe.*;        //SimpleUniverse
import com.sun.j3d.utils.geometry.*;        //Primitive
import javax.vecmath.*;                     //Point3f,Color3f

public class Ja66 extends Applet{

    private SimpleUniverse simpleU;
    private BoundingSphere bounds = new BoundingSphere(new Point3d(), 10.0);

    public void init(){

        //ץåȤCanvas3Dɲ
        setLayout(new BorderLayout());
        Canvas3D canvas = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
        add(canvas, BorderLayout.CENTER);

        //󥰥դ
        simpleU = new SimpleUniverse(canvas);
        simpleU.getViewingPlatform().setNominalViewingTransform();

        //󥰥դκ
        simpleU.addBranchGraph(createSceneGraph());
    }

    private BranchGroup createSceneGraph(){

        BranchGroup branchG0 = new BranchGroup();

        //طʿ̵꤬Ϲ
        Background background = new Background(new Color3f(0.3f, 0.3f, 0.3f));
        background.setApplicationBounds(bounds);
        branchG0.addChild(background);

        //InterpolatorѤΥΡ
        TransformGroup transG0 = new TransformGroup();
        branchG0.addChild(transG0);

        //ɲ
        branchG0.addChild(createDirectionalLight());        //ʿԸ
        transG0.addChild(createPointLight());               //

        //Appearance
        Appearance ap = new Appearance();
        Material ma = new Material();
        ap.setMaterial(ma);

        //˵
        Sphere sphere = new Sphere(0.5f, Primitive.GENERATE_NORMALS, 80, ap);
        branchG0.addChild(sphere);

        //žΥ˥᡼
        transG0.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        Transform3D rotAxis = new Transform3D();
        Alpha rotationAlpha = new Alpha(-1, 4000);          //14s,֤
        RotationInterpolator rotator =                      //Yޤβž
            new RotationInterpolator(rotationAlpha, transG0, rotAxis,
                         0.0f, (float)Math.PI*2.0f);        //ϰ,λ
        rotator.setSchedulingBounds(bounds);
        transG0.addChild(rotator);

        branchG0.compile();

        return branchG0;
    }

    //ʿԸ
    private Light createDirectionalLight(){

        DirectionalLight lightD = new DirectionalLight(
                        true,                               //饤ON/OFF
                        new Color3f(1.0f, 1.0f, 0.0f),      //ο
                        new Vector3f(-1.0f, -1.0f, -1.0f)   //Τ
        );
        lightD.setInfluencingBounds(bounds);                //ƶϰ

        return lightD;
    }

    //
    private Light createPointLight(){

        PointLight lightP = new PointLight(
                  true,                           //饤ON/OFF
                  new Color3f(1.0f, 0.0f, 0.0f),  //֤θ
                  new Point3f(-0.7f, 0.0f, 0.0f), //ΰ
                  new Point3f(1.0f, 0.0f, 0.0f)   //θconstant,linear,quadratic
        );
        lightP.setInfluencingBounds(bounds);      //ƶϰ

        return lightP;
    }

    public void destroy(){

        simpleU.cleanup();
    }

    public static void main(String[] args){    //Application

        MainFrame frame = new MainFrame(new Ja66(), 512, 512);
    }
}

